Summary: The XEmacs editor
Name: xemacs
%define version 20.4
Version: %{version}
Release: 1
Copyright: GPL
Group: Applications/Editors/Emacs
Source0: ftp://ftp.xemacs.org/pub/xemacs/xemacs-%{version}/xemacs-%{version}.tar.gz
Source1: ftp://ftp.xemacs.org/pub/xemacs/xemacs-%{version}/xemacs-%{version}-mule.tar.gz
Source2: xemacs-README.i386-pc-linux
Source3: xemacs.wmconfig
Url: http://www.xemacs.org/
Buildroot: /var/tmp/xemacs-root
# we don't know it work on Intel and Sparc only - yet
ExclusiveArch: i386 sparc

%description
XEmacs is a version of Emacs, compatible with and containing many 
improvements over GNU Emacs, written by Richard Stallman of the 
Free Software Foundation.  It was originally based on an early release 
of GNU Emacs Version 19, and has tracked subsequent releases of GNU 
Emacs as they have become available.
This XEmacs distribution has been splitted in some rpm :
- xemacs-%{version}        : the main part
- xemacs-el-%{version}     : elisp sources (optional)
- xemacs-info-%{version}   : info files (optional)
- xemacs-extras-%{version} : files in conflict with emacs
(Install xemacs-extras if you do not have emacs installed.)

This package includes the standard XEmacs binary the most people will use
(dynamically linked, with both X11 and TTY (ncurses) support, but without
mule (MUlti-Lingual Emacs - Asian character set) support. You might be able
to taylor XEmacs to your use by checking out the following packages also
available:
- xemacs-static-%{version} : static link with X11, ncurses, NO mule
- xemacs-X11-%{version}    : dynamic link with X11, NO ncurses, NO mule
- xemacs-mule-%{version}   : dynamic link with X11, NO ncurses, mule
- xemacs-noX-%{version}    : dynamic link with NO X11, ncurses, NO mule

%package el
Summary: .el source files for XEmacs
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}
%description el
This package contains the .el source files. This package is not
necessary to run XEmacs.

%package info
Summary: info files for XEmacs
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}
%description info
Info files -- Install this package if you want the info files 
distributed with XEmacs.

%package static
Summary: static linked xemacs
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}
%description static
Statically linked xemacs -- independent of the libraries installed. It 
is compiles with X11 and TTY (ncurses) support, but without mule (MUlti-Lingual
Emacs - Asian character set) support.

%package extras
Summary: files which conflict with GNU Emacs
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}
Conflicts: emacs
%description extras
These files are common between GNU Emacs and XEmacs. If you do not 
have GNU Emacs installed, be sure to install this package as well 
when you install XEmacs.

%package mule
Summary: XEmacs binary with mule (MUlti-Lingual Emacs) support
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}
%description mule
This package includes an xemacs binary with support for MUlti-Lingual Emacs,
espacially the Asian character set. It is needed only if need to use Asian
characters. It is compiled with X11 support only, so you won't be able to
use it in a TTY (ncurses) mode.

%package noX
Summary: XEmacs binary without X11 support (yeah, that's correct)
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}
%description noX
This package includes a XEmacs binary that can be used to run XEmacs in
console mode (ncurses interface). If you happen be one of those geeks that
like XEmacs featire set a lot, but can't stand X11 or can't use X11 always,
this binary is from you. It is *much* lighter than the standard X11 version of
XEmacs, so you can actually enjoy a faster and smaller XEmacs.

%package X11
Summary: XEmacs binary without ncurses support
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}
%description X11
This package includes a XEmacs binary you'll want to use if you don't ever
run XEmacs on the standard console (ncurses interface). Not having the TTY
support compiled in saves some memory.

%changelog
* Sat Apr 11 1998 Cristian Gafton <gafton@redhat.com>
- updated to 20.4
- new package xemacs-mule with mule support
- Changed spec file almost completely

* Fri Dec  5 1997 Otto Hammersmith <otto@redhat.com>
- refixed perl problem.
- added wmconfig

* Tue Dec  2 1997 Otto Hammersmith <otto@redhat.com>
- added changelog
- configure for ncurses
- removed sound support on i386
- moved buildroot to /var/tmp

%prep
%setup -q -b 1

%build
for flag in $RPM_ARCH-redhat-linux \
	--with-gnu-make \
	--with-gpm=no \
	--with-sound=none \
	--with-pop --mail-locking=flock \
	--with-clash-detection \
	--debug=no --error-checking=none \
	--prefix=/usr --lockdir=/var/lock/xemacs \
	; do
XEMACS_CONFIG="$XEMACS_CONFIG $flag"
done
CFLAGS="$RPM_OPT_FLAGS"
LDFLAGS=-s 

# standard: X11 and console support. No mule, though.
./configure $XEMACS_CONFIG --with-x11 \
	--with-dialogs=athena3d \
	--with-scrollbars=lucid --with-menubars=lucid \
	--with-xpm --with-xface \
	--with-mule=no \
	--with-tty=yes --with-ncurses

# This is crazy, but it works...

# X11 support only
(rm -rf $RPM_ARCH-linux-X11
mkdir -p $RPM_ARCH-linux-X11
cd $RPM_ARCH-linux-X11
../configure $XEMACS_CONFIG --with-x11 --with-tty=no \
	--with-dialogs=athena3d \
	--with-scrollbars=lucid --with-menubars=lucid \
	--with-xpm --with-xface \
	--with-mule=no
cat >> Makefile <<EOF

variant: \${GENERATED_HEADERS} \${MAKE_SUBDIR}
EOF
)

# X11 and mule support. Mule in console is extremely lame, so we leave the
# console out
(rm -rf $RPM_ARCH-linux-mule
mkdir -p $RPM_ARCH-linux-mule
cd $RPM_ARCH-linux-mule
../configure $XEMACS_CONFIG --with-x11 --with-tty=no \
	--with-dialogs=athena3d \
	--with-scrollbars=lucid --with-menubars=lucid \
	--with-xpm --with-xface \
	--with-mule=yes
cat >> Makefile <<EOF

variant: \${GENERATED_HEADERS} \${MAKE_SUBDIR}
EOF
)

# X11, static version (why do we need this ?!)
# we leave the tty support in - now talk about a bloated static
# executable....:-(. Also, we sacrifice mule users. Sorry :-(
(rm -rf $RPM_ARCH-linux-static
mkdir -p $RPM_ARCH-linux-static
cd $RPM_ARCH-linux-static
LDFLAGS="$LDFLAGS -Bstatic" ../configure $XEMACS_CONFIG --with-x11 \
	--with-dialogs=athena3d \
	--with-scrollbars=lucid --with-menubars=lucid \
	--with-xpm --with-xface \
	--with-tty=yes --with-ncurses \
	--with-mule=no
cat >> Makefile <<EOF

variant: \${GENERATED_HEADERS} \${MAKE_SUBDIR}
EOF
)

# noX version - no X support, just the console
(rm -rf $RPM_ARCH-linux-noX
mkdir -p $RPM_ARCH-linux-noX
cd $RPM_ARCH-linux-noX
../configure $XEMACS_CONFIG --with-x11=no \
	--with-tty=yes --with-ncurses \
	--with-mule=no
cat >> Makefile <<EOF

variant: \${GENERATED_HEADERS} \${MAKE_SUBDIR}
EOF
)

# Now we build everything. Don't you *love* fast build machines ?
make ldflags="-s -L/usr/X11R6/lib"
make -C $RPM_ARCH-linux-noX variant ldflags="-s"
make -C $RPM_ARCH-linux-static variant ldflags="-s -static -L/usr/X11R6/lib"
make -C $RPM_ARCH-linux-X11 variant ldflags="-s -L/usr/X11R6/lib"
make -C $RPM_ARCH-linux-mule variant ldflags="-s -L/usr/X11R6/lib"

%install
rm -rf $RPM_BUILD_ROOT
make install-arch-dep install-arch-indep \
	prefix=$RPM_BUILD_ROOT/usr \
	lockdir=$RPM_BUILD_ROOT/var/lock/xemacs
for i in static X11 mule noX ; do 
	install -m 755 $RPM_ARCH-linux-$i/src/xemacs $RPM_BUILD_ROOT/usr/bin/xemacs-$i
done
cp $RPM_SOURCE_DIR/xemacs-README.i386-pc-linux README.i386-pc-linux

# Build file listings. (and make movemail setgid mail on RHL)

DIR="$RPM_BUILD_ROOT/usr/lib/xemacs-%{version}"
INFO="*.info*"
EL="*.el"

find $DIR -type d |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) %dir #g" > rpm-files

find $DIR -name $INFO -type f |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) #g" > rpm-info

find $DIR -not -name $INFO -name $EL -type f |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) #g" > rpm-el-files

find $DIR -not -name $INFO -not -name $EL -type f |
  sed -e "
    s#^$RPM_BUILD_ROOT\(.*movemail\)#%attr(2755, root, mail) \1#g
    s#^$RPM_BUILD_ROOT#%attr(-, root, root) #g
  " >> rpm-files

install -m 755 -d $RPM_BUILD_ROOT/etc/X11/wmconfig
install -m 644 -o root -g root $RPM_SOURCE_DIR/xemacs.wmconfig $RPM_BUILD_ROOT/etc/X11/wmconfig/xemacs

%files -f rpm-files
%config /etc/X11/wmconfig/xemacs
%attr(-, root, root) %doc INSTALL README COPYING GETTING.GNU.SOFTWARE PROBLEMS 
%attr(-, root, root) %doc etc/NEWS etc/MAILINGLISTS BUGS README.i386-pc-linux
%attr(-, root, root) %doc Installation
%config %attr(-, root, root) /usr/bin/xemacs
%attr(-, root, root) /usr/bin/xemacs-%{version}
%attr(-, root, root) /usr/bin/pstogif
%attr(-, root, root) /usr/bin/install-sid
%attr(-, root, root) /usr/bin/send-pr
%attr(-, root, root) /usr/bin/gnuclient
%attr(-, root, root) /usr/bin/gnuattach
%attr(-, root, root) /usr/bin/gnudoit
%attr(-, root, root) /usr/man/man1/xemacs.1
%attr(-, root, root) /usr/man/man1/gnuserv.1
%attr(-, root, root) /usr/man/man1/gnuclient.1
%attr(-, root, root) /usr/man/man1/gnuattach.1
%attr(-, root, root) /usr/man/man1/gnudoit.1
%attr(-, root, root) %dir /usr/lib/xemacs/
%attr(-, root, root) %dir /usr/lib/xemacs/site-lisp
%attr(-, root, root) %dir /var/lock/xemacs

%files el -f rpm-el-files

%files info -f rpm-info

%files extras
%attr(-, root, root) /usr/bin/b2m
%attr(-, root, root) /usr/bin/ctags
%attr(-, root, root) /usr/bin/etags
%attr(-, root, root) /usr/bin/rcs-checkin
%attr(-, root, root) /usr/man/man1/ctags.1
%attr(-, root, root) /usr/man/man1/etags.1

%files static
%attr(-, root, root) /usr/bin/xemacs-static

%files noX
%attr(-, root, root) /usr/bin/xemacs-noX

%files mule
%attr(-, root, root) /usr/bin/xemacs-mule

%files X11
%attr(-, root, root) /usr/bin/xemacs-X11

%clean
rm -rf $RPM_BUILD_ROOT
